%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.1, (the "License"); you may not use this file except in
%% compliance with the License. You should have received a copy of the
%% Erlang Public License along with this software. If not, it can be
%% retrieved via the world wide web at http://www.erlang.org/.
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Initial Developer of the Original Code is Ericsson Utvecklings AB.
%% Portions created by Ericsson are Copyright 1999, Ericsson Utvecklings
%% AB. All Rights Reserved.''
%% 
%%     $Id$
%%

-module(r7_mod).
-compile(r7).

-export([sort_on_r7_node/1, sorter/3]).

-include("test_server.hrl").

sorter(Receiver, Ref, List) ->
    Receiver ! {Ref, lists:sort(List)}.

sort_on_r7_node(List) when list(List) ->    
    ?line Pa = filename:dirname(code:which(?MODULE)),
    ?line {X, Y, Z} = now(),
    ?line NodeName = list_to_atom("r7_"
				  ++ integer_to_list(X)
				  ++ integer_to_list(Y)
				  ++ integer_to_list(Z)),
    ?line {ok, Node} = ?t:start_node(NodeName,
				     peer,
				     [{args, " -pa " ++ Pa},
				      {erl, [{release, "r7b01"}]}]),
    ?line Ref = make_ref(),
    ?line spawn_link(Node, ?MODULE, sorter, [self(), Ref, List]),
    ?line SortedPids = receive {Ref, SP} -> SP end,
    ?line true = ?t:stop_node(Node),
    ?line SortedPids.


